/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef DEVFS_OPS_H
#define DEVFS_OPS_H

#include <fs/fs.h>
#include <drv/event.h>
#include <sys/types.h>
#include <stdbool.h>

int devfs_mount(const struct fs_mount *m, struct fs_ret *r);
int devfs_mkdir(const struct fs_mkdir *m, const struct fs_mp *mp,
    const union inode_result *i, struct fs_ret *r);
int devfs_open(const struct fs_open *o, const struct fs_mp *mp,
    const union inode_result *i, struct fs_ret *r);
int devfs_read(const struct fs_read *r, struct fs_ret *ret);
int devfs_read_nb(const struct fs_read *r);
int devfs_write(const struct fs_write *w, struct fs_ret *r);
int devfs_stat(const struct fs_stat *s, const struct fs_mp *mp,
    const union inode_result *i, struct fs_ret *r);
int devfs_close(struct fs_fd *fd);
int devfs_search(const char *path, const struct fs_mp *mp,
    union inode_result *inode, struct fs_ret *r);
int devfs_status(const char *node, const struct drv_event_ops *const ops,
    bool available, mode_t mode, void *args);
int devfs_flags(const union inode_result *i);
int devfs_update(struct fs_mp_prv *pr);
int devfs_mknod(const char *path, mode_t mode, dev_t dev,
    const struct drv_event_ops *const ops, struct fs_mp_prv *mp);
int devfs_unlink(const char *path, struct fs_mp_prv *mp);
const struct devfs_ops *devfs_ops(const struct fs_mp_prv *pr, const char *node);

#endif
